Read("CodeFunctions.g");

FileOldInfo:="DATA/PreviousOldTable";

ListOldInfo:=ReadAsFunction(FileOldInfo)();

GetValueOldEntry_MaxK:=function(n,d)
  local eRec;
  eRec:=ListOldInfo[n].LEnt[d];
  if IsBound(eRec.v) then
    return eRec.v;
  fi;
  if IsBound(eRec.u) then
    return eRec.u-1;
  fi;
  Error("Nothing assigned. Pretty bad");
end;

GetMaximumValueD_OldEntry:=function(n,k)
  local ListFeasibleD, d, eK;
  ListFeasibleD:=[];
  for d in [1..n]
  do
    eK:=GetValueOldEntry_MaxK(n,d);
    if eK >= k then
      Add(ListFeasibleD, d);
    fi;
  od;
  return Maximum(ListFeasibleD);
end;



GetMaximumValueD:=function(n,k)
  local DmaxOld, d, eRec1;
  DmaxOld:=GetMaximumValueD_SimpleLP(n,k);
  d:=DmaxOld;
  while(true)
  do
    eRec1:=ComputeSpecificValue(n,k,d);
    if eRec1.TheDim>0 then
      return d;
    fi;
    if d=1 then
      Error("We should not be here");
    fi;
    d:=d-1;
  od;
  return d;
end;



FunctorD_to_K:=function(TheFuncD)
  local TheFuncK;
  TheFuncK:=function(n,d)
    local ListFeasibleK, Dmax, k, RetValue;
    ListFeasibleK:=[];
    for k in [1..n]
    do
      Dmax:=TheFuncD(n,k);
      if d <= Dmax then
        Add(ListFeasibleK, k);
      fi;
    od;
    if Length(ListFeasibleK)=0 then
      RetValue:=0;
    else
      RetValue:=Maximum(ListFeasibleK);
    fi;
    return RetValue;
  end;
  return TheFuncK;
end;


MonotonicityProperty:=function(Table1, Table2)
  local nbPlus, nbZero, nbMinus, nMax, n, u, eVal1, eVal2, eDiff;
  nbPlus:=0;
  nbZero:=0;
  nbMinus:=0;
  nMax:=Length(Table1);
  for n in [1..nMax]
  do
    for u in [1..n]
    do
      eVal1:=Table1[n][u];
      eVal2:=Table2[n][u];
      eDiff:=eVal1 - eVal2;
      if eDiff>0 then
        nbPlus:=nbPlus+1;
      fi;
      if eDiff=0 then
        nbZero:=nbZero+1;
      fi;
      if eDiff<0 then
        nbMinus:=nbMinus+1;
      fi;
    od;
  od;
  Print("  nbPlus=", nbPlus, "\n");
  Print("  nbZero=", nbZero, "\n");
  Print(" nbMinus=", nbMinus, "\n");
end;


ComputeSpecificTable:=function(nLocMax, TheFunc)
  local TheTable, n, eLine, u, eVal;
  TheTable:=[];
  for n in [1..nLocMax]
  do
    eLine:=[];
    for u in [1..n]
    do
      eVal:=TheFunc(n,u);
      Add(eLine, eVal);
    od;
    Add(TheTable, eLine);
  od;
  return TheTable;
end;

GetMaximumValueK:=FunctorD_to_K(GetMaximumValueD);
GetMaximumValueK_SimpleLP:=FunctorD_to_K(GetMaximumValueD_SimpleLP);

nMax:=16;
TheTableK:=ComputeSpecificTable(nMax, GetMaximumValueK);
TheTableD:=ComputeSpecificTable(nMax, GetMaximumValueD);
TheTableK_SimpleLP:=ComputeSpecificTable(nMax, GetMaximumValueK_SimpleLP);
TheTableD_SimpleLP:=ComputeSpecificTable(nMax, GetMaximumValueD_SimpleLP);



FuncPrintTableNoth:=function(eFile, OthStr, TheTable, TheTableOld)
  local n, output, i, j, eVal, eValOld;
  n:=Length(TheTable);
  RemoveFileIfExist(eFile);
  output:=OutputTextFile(eFile, true);
  AppendTo(output, "\\begin{center}\n");
  AppendTo(output, "\\begin{tabular}{||c||");
  for i in [1..n]
  do
    AppendTo(output, "c|");
  od;
  AppendTo(output, "}\n");
  AppendTo(output, "\\hline\n");
  AppendTo(output, "n/", OthStr);
  for i in [1..n]
  do
    AppendTo(output, " & ", i);
  od;
  AppendTo(output, "\\\\\n");
  AppendTo(output, "\\hline\n");
  AppendTo(output, "\\hline\n");
  for i in [1..n]
  do
    AppendTo(output, i);
    for j in [1..i]
    do
      eVal:=TheTable[i][j];
      eValOld:=TheTableOld[i][j];
      if eVal=eValOld then
        AppendTo(output, " & ", eVal);
      else
        AppendTo(output, " & ", eVal, "(", eValOld, ")");
      fi;
    od;
    for j in [i+1..n]
    do
      AppendTo(output, " & ");
    od;
    AppendTo(output, "\\\\\n");
  od;
  AppendTo(output, "\\hline\n");
  AppendTo(output, "\\end{tabular}\n");
  AppendTo(output, "\\end{center}\n");
  CloseStream(output);
end;

FileTable:="TEX/Table_Dmax_pre.tex";
FuncPrintTableNoth(FileTable, "k", TheTableD, TheTableD_SimpleLP);
LATEX_Compilation(FileTable);

FileTable:="TEX/Table_Kmax_pre.tex";
FuncPrintTableNoth(FileTable, "d", TheTableK, TheTableK_SimpleLP);
LATEX_Compilation(FileTable);

