Read("CodeFunctions.g");

nMax:=20;

eDir:="ResultLCD_int/";

ListRec:=[];
for n in [1..nMax]
do
  for k in [1..n]
  do
    for d in [2..n]
    do
      FileSave:=Concatenation(eDir, "out", String(n), "_", String(k), "_", String(d), "_cdd");
      if IsExistingFile(FileSave) then
        Print("  n=", n, " k=", k, " d=", d, "\n");
        eRead:=ReadAsFunction(FileSave)();
        eRec:=rec(n:=eRead.n, k:=eRead.k, d:=eRead.d, dim:=eRead.TheDim);
        Add(ListRec, eRec);
      fi;
    od;
  od;
od;

ListDim:=List(ListRec, x->x.dim);
ePerm:=SortingPerm(ListDim);

NewListRec:=Permuted(ListRec, ePerm);

ListDataTable:=[];
for eRec in NewListRec
do
  n:=eRec.n;
  k:=eRec.k;
  d:=eRec.d;
  Print(" n=", n, " k=", k, " d=", d, "\n");
  FileSave:=Concatenation(eDir, "out", String(n), "_", String(k), "_", String(d), "_cdd");
  FileDataInt:=Concatenation(eDir, "out", String(n), "_", String(k), "_", String(d), "_int");
  eRead:=ReadAsFunction(FileSave)();
  if IsExistingFile(FileDataInt)=false then
    NewRec:=GetIntegralPoints(eRead);
    Print(" dim=", eRead.TheDim, " |FAC|=", Length(NewRec.FACred), " |EXT|=", Length(NewRec.EXT), " |ListPoint|=", Length(NewRec.ListPoint), "\n");
    SaveDataToFile(FileDataInt, NewRec);
  fi;
  NewRec:=ReadAsFunction(FileDataInt)();
  eDataTable:=rec(n:=n, k:=k, d:=d, dim:=eRead.TheDim, nbFac:=Length(NewRec.FACred), nbExt:=Length(NewRec.EXT), nbPoint:=Length(NewRec.ListPoint));
  Add(ListDataTable, eDataTable);
od;

FileTable:="TEX/TableLowNbPoint_pre.tex";
nbCol:=2;
RemoveFileIfExist(FileTable);
output:=OutputTextFile(FileTable, true);
AppendTo(output, "\\begin{center}\n");
AppendTo(output, "\\begin{tabular}{|");
for iCol in [1..nbCol]
do
  AppendTo(output, "|c|c|");
od;
AppendTo(output, "|}\n");
AppendTo(output, "\\hline\n");
for iCol in [1..nbCol]
do
  if iCol>1 then
    AppendTo(output, " & ");
  fi;
  AppendTo(output, "\$(n,k,d)\$ & \$(dim, F,V,P)\$");
od;
AppendTo(output, "\\\\\n");
AppendTo(output, "\\hline\n");
nbData:=Length(ListDataTable);
nbLine:=UpperInteger(nbData/nbCol);
for iLine in [1..nbLine]
do
  for iCol in [1..nbCol]
  do
    if iCol>1 then
      AppendTo(output, " & ");
    fi;
    iPos:=nbCol*(iLine-1) + iCol;
    if iPos<=nbData then
      eDat:=ListDataTable[iPos];
      eDim:=eDat.dim-1;
      str1:=Concatenation("(", String(eDat.n), ",", String(eDat.k), ",", String(eDat.d), ")");
      str2:=Concatenation("(", String(eDim), ",", String(eDat.nbFac), ",", String(eDat.nbExt), ",", String(eDat.nbPoint), ")");
      strWrite:=Concatenation(str1, " & ", str2);
      AppendTo(output, strWrite);
    else
      AppendTo(output, " & ");
    fi;
  od;
  AppendTo(output, "\\\\\n");
od;
AppendTo(output, "\\hline\n");
AppendTo(output, "\\end{tabular}\n");
AppendTo(output, "\\end{center}\n");
CloseStream(output);

LATEX_Compilation(FileTable);
